'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _eventemitter = require('eventemitter3');

var _eventemitter2 = _interopRequireDefault(_eventemitter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Model = function () {
  function Model() {
    _classCallCheck(this, Model);

    this.initState = {};

    this.ee = new _eventemitter2['default']();
    this.state = _extends({}, this.initState, {
      __setStateCounter: 0
    });
  }

  Model.prototype.on = function on(event, listener) {
    this.ee.on(event, listener);
  };

  Model.prototype.setState = function setState(nextState) {
    var prevState = this.state;
    var state = _extends({}, prevState, nextState, {
      __setStateCounter: prevState.__setStateCounter + 1
    });
    this.ee.emit('beforeUpdate', prevState, state);
    this.state = state;
    this.ee.emit('didUpdate', state, prevState);
  };

  Model.prototype.compute = function compute() {};

  return Model;
}();

exports['default'] = Model;